#!/bin/sh
# Send advice for cml user. (adviceuser)
#	Copyright 1995,1996 (C) SAITOH-Ely-Yasuhiro.
#	All rights reserved.
VERSION=@VER@

SENDMAIL=@SENDMAIL@

PATH=@PATH@

MAIL=/tmp/MAIL.$$
TEMP=/tmp/TEMP.$$
SEND=/tmp/SEND.$$
trap "rm -f $MAIL $TEMP $SEND; exit 0" 0 1 2 3 15

c=
T="`echo 'test\c'`"
if [ "$T" = "test" ]
then
	c="\c"
fi

n=
T="`echo -n 'test'`"
if [ "$T" = "test" ]
then
	n="-n"
fi

#
# Set local environment.
#
DRIVER=@DRIVER@
DOMAIN=@DOMAIN@

if [ $# -ne 1 ]
then
	echo "Usage: adviceuser ML-Name" 1>&2
	exit 1
fi

ML=$1

# Set default value.
. $DRIVER/config.default

if [ -f $DRIVER/$ML/config.$ML ]
then
	. $DRIVER/$ML/config.$ML
fi

# Member list
LIST=$DRIVER/$ML/$ML-member

# Deliver list
DELV=$DRIVER/$ML/$ML-list

if [ ! -f $LIST ]
then
	cat $DELV > $LIST
fi

if [ ! "$MESSAGES" ]
then
	MESSAGES=messages
fi

# Check change domain name.
if [ "$GENERICFROM" ]
then
	DOMAIN=$GENERICFROM
fi

NG=0
set `head -1 < $LIST` . . . . .
echo $1 | egrep '[0-9][0-9][0-9][0-9]' >/dev/null 2>&1 
if [ $? -ne 0 ]
then
	NG=1
fi

echo $4 | egrep '[0-9][0-9][0-9][0-9]|nobody' >/dev/null 2>&1 
if [ $? -ne 0 ]
then
	NG=1
fi

set `tail -1 < $LIST` . . . . .
echo $1 | egrep '[0-9][0-9][0-9][0-9]' >/dev/null 2>&1 
if [ $? -ne 0 ]
then
	NG=1
fi

echo $4 | egrep '[0-9][0-9][0-9][0-9]|nobody' >/dev/null 2>&1 
if [ $? -ne 0 ]
then
	NG=1
fi

if [ $NG -eq 1 ]
then
	echo "adviceuser: Maybe addresslist is not CML format." 1>&2
	exit 1
fi

set `wc -l $LIST`
L=$1
I=1

while [ $I -le $L ]
do
	set `head -${I} $LIST | tail -1` "()" "()" "()"
	if [ "$3" != "()" ]
	then
		AD=`echo $3|sed -e 's/.*(//' -e 's/).*//' -e 's/.*<//' -e 's/>.*//'`
		NUM=$1
		MODE=$2
		KEY=$4
		echo $n "Sending $AD ... $c"
		echo "To: $AD"                                     > $MAIL
		echo "From: $ML-request@$DOMAIN ($ML ML admin)"   >> $MAIL
		echo "Subject: ML Driver CML Information."        >> $MAIL
		echo "X-ML-Driver: CMLTOOL (Version $VERSION)"    >> $MAIL

		if [ "$SENDER" ]
		then
			echo "Sender: $SENDER"                     >> $MAIL
		fi

		if [ "$PRECEDENCE" ]
		then
			echo "Precedence: $PRECEDENCE"             >> $MAIL
		fi

		echo ""                                            >> $MAIL

		SEDADD=`echo $AD | sed -e 's/\//\\\\\//g'`
		echo "s/%NuMbEr%/$NUM/
		      s/%AdDrEsS%/$SEDADD/
		      s/%kEyWd%/$KEY/
		      s/%AdMiN%/$ML-request@$DOMAIN/
		      s/%CNtLAdRs%/$ML-control@$DOMAIN/
		      s/%MlNaMe%/$ML@$DOMAIN/
		      s/%mOdE%/$MODE/" > $TEMP

		if [ "$USECHECK" != "DONT" ]
		then
			echo "s/^((//" >> $TEMP
		else
			echo "/^((/d"  >> $TEMP
		fi

		if [ "$USEMEMBER" != "DONT" ]
		then
			echo "s/^))//" >> $TEMP
		else
			echo "/^))/d"  >> $TEMP
		fi

                if [ "$ARCHIVE" = "DO" ]
                then
			if [ "$ACCESSFREE" = "DO" ]
			then
				echo "s/^&&//" >> $TEMP
				echo "/^%%/d"  >> $TEMP
			else
				echo "s/^%%//" >> $TEMP
				echo "/^&&/d"  >> $TEMP
			fi
		else
			echo "/^%%/d" >> $TEMP
			echo "/^&&/d" >> $TEMP
                fi

		cat $MAIL $DRIVER/$MESSAGES/changedriver | sed -f $TEMP > $SEND

		if [ -f $DRIVER/$ML/info.$ML ]
		then
			echo "--<Information of $ML ML>----------"    >> $SEND
			cat $DRIVER/$ML/info.$ML		      >> $SEND
		fi

		sed -f $TEMP < $DRIVER/$MESSAGES/manual		      >> $SEND
		cat $SEND | b64decode | $SENDMAIL -oi -t -f$ML-request@$DOMAIN
		echo "Done."
	fi
	I=`expr $I + 1`
done

exit 0
